// File: dense_matrix_lapack.h      -*- c++ -*-
// Author: Suvrit Sra
// Time-stamp: <05 September 2005 11:17:51 AM CDT --  suvrit>

#ifndef _MY_DENSE_LAPACK_H
#define _MY_DENSE_LAPACK_H

#include "dense_matrix.h"
#include <gsl/gsl_blas.h>

namespace SSLib {
  
  /**
   * This matrix class does its operations using system tuned blas, and also
   * provides an interface to some of the LAPACK operations.
   * TODO: For the future, perhaps
   */
  class dense_matrix_lapack : public dense_matrix {
  public:
    virtual int add (matrix* b);
    virtual int mul (matrix* b, bool transA, bool transB);
  };
}
#endif // _MY_DENSE_LAPACK_H
